
//Torch include file for Magical African Nights

//By Mick Hazelgrove

#declare beakR = difference{
object{sphere{<0,0,0> 1.00 }scale<1.5,1,1>}
object{sphere{<-0.25,-0.4,0> 1.00 }}
}
#declare beakL = difference{
object{sphere{<0,0,0> 1.00 }scale<1.5,1,1>}
object{sphere{<0.25,-0.4,0> 1.00 }}
}
#declare beak = union{
object{beakR clipped_by { object { plane {z,-0.3} } } translate<0,0,0.3> rotate y*-270 }
object{beakL clipped_by { object { plane {z,-0.3} } } translate<0,0,0.3> rotate y*-90 }
}
#declare underbeak = object{sphere{<0,-0.4,0> 0.4 }}
#declare pecker =union{
object{beak rotate y*-90}
object{underbeak scale<3,1,1.6> rotate z*-17.5}
}

#declare fullbeak = object{pecker clipped_by { object { plane {x,0.3} } }texture{T_Gold_1A}}

//------------------------------------------
//*******************Head*******************
//------------------------------------------
#declare head = difference{
object{sphere{<0,0,0> 1.75}scale<1.5,1,1>}
object{sphere{<-0.65,0.0,3.10> 1.00 }scale<1.5,1,0.5>}
object{sphere{<-0.65,0.0,-3.10> 1.00 }scale<1.5,1,0.5>}
}


#declare bonce = union{
object{fullbeak scale<1.25,1,1>}
object{head rotate z*-10 translate<2.5,-0.25,0>}
//Neck
object{cone{1*y, 0.3,-1*y, 0.8}scale<3,3,2.5> rotate z*15 translate<3.25,-1.75,0>}
//eyes
object{sphere{<1.45,0.0,1.05> 0.6}texture{Lightening1}}
object{sphere{<1.45,0.0,-1.05> 0.6}texture{Lightening1}}
}




//------------------------------------------
//**************Place Head******************
//------------------------------------------
#declare ring_of_heads = union{
#declare Radius = 8
#declare stAngle = 72
#declare Count = 36
#declare rinc = 0

#while (Count <216)
#declare Angle = radians(stAngle*Count)

#declare cox = Radius*(sin(Angle ))
#declare coy = Radius*(cos(Angle ))
#declare point1 = <cox,0,coy>

object{bonce
rotate y*rinc rotate y*162
      translate point1
      texture{Ebony}
      }

#declare point1 = <cox,0,coy>
#declare Count = Count+36
#declare rinc = rinc + 72
#end
}

//---------------Spikes---------------


#declare Spikes = union{
#declare Radius = 9.5
#declare stAngle = 3
#declare Count = 3
#declare rinc = 0

#while (Count <123)
#declare Angle = radians(stAngle*Count)

#declare cox = Radius*(sin(Angle ))
#declare coy = Radius*(cos(Angle ))
#declare point1 = <cox,0,coy>

object{cone{1*z,0.00,-1*z, 0.3  scale 2}

rotate y*rinc
      translate point1
      translate<0 ,-4.9,0>
       texture{T_Gold_1A}
      }

#declare point1 = <cox,0,coy>
#declare Count = Count + 3
#declare rinc = rinc + 9
#end
}
//---------------Twisted post-----------------
#declare Rad = 1//same or larger than SDiam
#declare No_of_Strands = 3
#declare StAngle = 5
#declare Inc = 360/No_of_Strands
#declare SDiam = 1.00
#declare SDiam_inc = 0.00
#declare Count = 5
#declare VertInc = 0.15 //if bigger then .15 spheres show
#declare Iterations = 0

#declare Twister = union{
#while(Count <1440)

          #while(Iterations < 360)

            #declare Angle = radians((StAngle + Iterations) + Count)
            #declare Cox = Rad *(sin(Angle))
            #declare Coy = Rad*(cos(Angle))
            #declare Point = <Cox,VertInc,Coy>
                object{sphere{<0,0,0>,SDiam + SDiam_inc}
                translate Point}
            #declare Iterations = Iterations +Inc
          #end

           #declare SDiam_inc = SDiam_inc + 0.00
        #declare Count = Count + 5
      #declare VertInc = VertInc + 0.15
   #declare Iterations = 0
#end
}

//--------------put it together--------------

#declare torch = union{
object{ring_of_heads rotate y*180}
object{Spikes rotate y *180}
object{cone{1*y,0.75,-1*y, 1.0} rotate x*180 scale <4,6,4> texture{Ebony} normal {radial 2 frequency 30 scallop_wave}}
object{torus{4,0.4} translate<0,4.5,0>}
object{torus{3.9,0.4} translate<0,3.5,0>}
object{torus{6.5,1} translate<0,-5,0>}
//object{cylinder{<0,-15,0>,<0,-6.5,0>, 2.00}}
object {Twister scale 1.5 translate y*-68 texture {Ebony}scale 0.75}
object{sphere{<0,-6,0> 6}texture{Ebony} normal {radial 0.33  turbulence 0.5 frequency 66 scallop_wave}}
object{torus{2.5,0.75} translate<0,-12.00,0> texture{T_Gold_1A}
normal {radial 1 frequency 25 scallop_wave}}
no_shadow
}
